// interactive test program for heaps

import java.util.*;

public class InteractiveHeapTest {

    public static void main(String[] args) {
        Scanner keyboard = new Scanner(System.in);
        HeapViewer hv = new HeapViewer(500, 400);
        hv.setFontSize(14);

        // construct a new heap containing some random elements
        System.out.print("Enter initial size of heap: ");
        String input = keyboard.nextLine();
        if (input.equals("")) input = "4"; // default size
        int numElements = Integer.parseInt(input);
        Heap<String> heap = hv.randomHeap(numElements);
        System.out.println(heap);
        hv.draw(heap);

        // test size and peek methods
        System.out.printf("Heap contains %d elements\n", heap.heapSize());
        System.out.printf("Smallest element is %s\n\n", heap.peek());

        // you can add more code here to test other methods

        // test add method
        System.out.println("Enter more elements to add to heap (RETURN when done)...");
        while (true) {
            input = keyboard.nextLine();
            if (input.equals("")) break;
            heap.add(input);
            hv.draw(heap);
            System.out.println(heap);
            hv.verify(heap);
        }
        System.out.printf("Heap contains %d items\n", heap.heapSize());
        System.out.printf("Smallest element is %s\n\n", heap.peek());

        // test remove method
        System.out.println("Hit RETURN to remove the smallest element (q to quit)...");
        while (!heap.isEmpty()) {
            input = keyboard.nextLine();
            if (input.equals("q")) break;
            System.out.printf("removed %s\n", heap.remove());
            System.out.println(heap);
            hv.draw(heap);
            hv.verify(heap);
        }
        if (heap.heapSize() == 0) {
            System.out.println("\nHeap is now empty");
        }
        hv.close();
    }

}
